#pragma once

#include "PluginProcessor.h"

//==============================================================================
class AudioPluginAudioProcessorEditor  : public juce::AudioProcessorEditor,
                                         private juce::Timer
{
public:
    explicit AudioPluginAudioProcessorEditor (AudioPluginAudioProcessor&);

    void resized() override;
    void paint (juce::Graphics& g) override;

private:
    auto getTypeOfAbsoluteChannel (bool isInput, int index) const
    {
        int busIndex = 0;
        const auto channelIndex = processorRef.getOffsetInBusBufferForAbsoluteChannelIndex (isInput, index, busIndex);
        const auto channelLayout = processorRef.getChannelLayoutOfBus (isInput, busIndex);
        return channelLayout.getTypeOfChannel (channelIndex);
    }

    void updateText();
    void timerCallback() override;

    AudioPluginAudioProcessor& processorRef;

    juce::TextButton button { "next channel" };
    juce::Label label;

    juce::ScopedValueSetter<std::function<void()>> scope { processorRef.channelChanged, [this] { updateText(); } };
};
